/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2016  Ciaran Anscomb
 *
 *  See COPYING.GPL for redistribution conditions. */

#ifndef XROAR_SDL_COMMON_H_
#define XROAR_SDL_COMMON_H_

#include <SDL_syswm.h>

#include "module.h"
#include "vo.h"
struct joystick_module;

extern unsigned sdl_window_x, sdl_window_y;
extern unsigned sdl_window_w, sdl_window_h;

extern struct vo_module vo_sdlgl_module;
extern struct vo_module vo_sdlyuv_module;
extern struct vo_module vo_sdl_module;
extern struct vo_module vo_null_module;

extern struct joystick_interface sdl_js_if_physical;
extern struct joystick_interface sdl_js_if_keyboard;
extern struct joystick_module sdl_js_internal;

extern struct vo_module * const sdl_vo_module_list[];
extern struct joystick_module * const sdl_js_modlist[];

void sdl_run(void);
void sdl_keyboard_init(void);
void sdl_keyboard_set_translate(_Bool);
void sdl_keypress(SDL_keysym *keysym);
void sdl_keyrelease(SDL_keysym *keysym);
void sdl_js_physical_shutdown(void);

void sdl_zoom_in(void);
void sdl_zoom_out(void);

// Fake "SDL_Window" type
typedef void SDL_Window;

#ifdef WINDOWS32

/* These functions will be in the windows32-specific code. */

void sdl_windows32_handle_syswmevent(SDL_SysWMmsg *);
void sdl_windows32_set_events_window(SDL_Window *sw);
void sdl_windows32_add_menu(SDL_Window *sw);
void sdl_windows32_remove_menu(SDL_Window *sw);

#endif

#endif  /* XROAR_SDL_COMMON_H_ */
